package de.mlessmann.certassist.openssl;

import de.mlessmann.certassist.DeleteRecursiveFileVisitor;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.Set;
import lombok.AccessLevel;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;

@Slf4j
@RequiredArgsConstructor(access = AccessLevel.PACKAGE)
@Getter
public class OpenSSLCertificateResult implements AutoCloseable {

    private final Path tmpDir;
    private final Path certificatePath;
    private final Path privateKeyPath;
    private final String certificateFingerPrint;

    @Override
    public void close() throws IOException {
        log.info("Cleaning up temporary output directory {}", tmpDir);
        Files.walkFileTree(tmpDir, Set.of(), Integer.MAX_VALUE, new DeleteRecursiveFileVisitor());
        Files.deleteIfExists(tmpDir);
    }
}
